<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|      http://www.dansoftaustralia.com/        |
\**********************************************/

//File: EggUserV2.php
//      Item
//By: Feeble - http://www.leaderless.net
//VERSION: 1.0Beta
//DATE: 17th April 2007
global $eggSelect, $context, $dontColourme, $debugMode, $enablePm;

/*
$debugMode:		please set to true if you have having any problems. It will then display more information to help solve this problem.

$dontColourme:	change this variable, it will reflect upon your array for eggs.
				REMEMBER: POSITION 0 IS THE FIRST ITEM IN THE ARRAY AKA THE EGG.
				DEFAULT IS 2, MEANING ANYTHING ABOVE THE TOMATO WILL GET A RANDOM
				COLOUR.

name: what the item will be called in the drop down box for users to select
image: image file name. FOR THIS RELEASE THIS HAS TO BE A GIF. IF THIS FAILS,
       IT WILL NOT WARN YOU, AND IT WILL SAVE AN UNALTERED VERSION IN THE EGGED FOLDER
taunt: the text used in custom titles, if admin allows.;
ratio: use this to adjust the image that will be put onto the avatar. the original are
       50px by 50px roughly.
karma: karma: alters the users karma, depending on egg used. positive is good, negative is bad karma.
*/

$enablePm = true;

$dontColourme = 2;

$eggSelect = array(
	array("name" => "Egg", "image"=>"eggedoriginal.gif", "taunt"=>"You've been Egg'd by ".$context['user']['name']."", "ratio"=>3/5, "karma"=>-5),
	array("name" => "Snowball", "image"=>"eggedsnowball.gif", "taunt"=>"".$context['user']['name']." hits you with a snowball", "ratio"=>1, "karma"=>-5),
	array("name" => "Tomato", "image"=>"eggedtomato.gif", "taunt"=>"".$context['user']['name']." squishes you with a tomato", "ratio"=>4/5, "karma"=>-5),
	array("name" => "Kiss", "image"=>"kissoriginal.gif", "taunt"=>"".$context['user']['name']." plants one on you", "ratio"=>4/5, "karma"=>5),
	array("name" => "Paintball", "image"=>"paintoriginal.gif", "taunt"=>"Got shot by ".$context['user']['name']."", "ratio"=>4/5, "karma"=>-5),
	array("name" => "Snowflake", "image"=>"flakeegg.gif", "taunt"=>$context['user']['name']." shares a little Xmas Spirit", "ratio"=>2/5, "karma"=>10)
	);
	
	
class item_EggUserV2 extends itemTemplate {

function getItemDetails() {

	$this->authorName = "Feeble";
	$this->authorWeb = "http://www.leaderless.net/";
	$this->authorEmail = "tsaphin@gmail.com";
	
	$this->name = "Egg Users Avatar V2";
	$this->desc = "Deface someone else's avatar with numerous items.";
	$this->price = 300;

	$this->require_input = true;
	$this->can_use_item = true;
}
	
function getAddInput() {
	global $modSettings, $settings, $boarddir, $sourcedir, $boardurl;
	$eggdirCheckGood = "<img src='".$settings['default_images_url']."/icons/package_installed.gif' />";
	$eggdirCheckBad = "<img src='".$settings['default_images_url']."/icons/package_old.gif' />";

	// Is GD installed....?
	$testGD = get_extension_funcs('gd');
	if(empty($testGD))
		$testGD = "<b>{$eggdirCheckBad}GD NOT FOUND, PLEASE CHECK TO SEE IF YOU HAVE THIS TOOLKIT INSTALLED</b><br/>";
	else
		$testGD = "<b>{$eggdirCheckGood}GD SUCCESSFULLY FOUND, ITEM SHOULD WORK</b><br/>";
	
	// Is Egged Dir Writable
	$eggdirCheck = "";

	if(is_dir($boarddir.'/egged'))
	{
		if (!is_writable($boarddir.'/egged'))
		{
			@chmod($boarddir.'/egged', 0777);
			if (!is_writable($boarddir.'/egged'))
				$eggdirCheck .= "<b>{$eggdirCheckBad}EGGED DIR IS NOT WRITABLE. Please manually chmod the directory @ ".$boarddir."/egged</b><br/>";
			else
				$eggdirCheck .= "<b>EGGED DIR FOUND AND WRITABLE</b><br/>";
		}
		else
			$eggdirCheck .= "<b>{$eggdirCheckGood}EGGED DIR FOUND AND WRITABLE</b><br/>";	
	}
	else
	{
		mkdir($boarddir.'/egged', 0777);
		if(is_dir($boarddir.'/egged'))
		{
			if (!is_writable($boarddir.'/egged'))
			{
				@chmod($boarddir.'/egged', 0777);
				if (!is_writable($boarddir.'/egged'))
					$eggdirCheck .= "<b>{$eggdirCheckBad}EGGED DIR IS NOT WRITABLE. Please manually chmod the directory @ ".$boarddir."/egged</b><br/>";
				else
					$eggdirCheck .= "<b>EGGED DIR FOUND AND WRITABLE</b><br/>";
			}
			else
				$eggdirCheck .= "<b>{$eggdirCheckGood}EGGED DIR FOUND AND WRITABLE</b><br/>";	
		}
		else
			$eggdirCheck .= "<b>{$eggdirCheckBad}EGGED DIR NOT FOUND, please create an egged directory @ ".$boarddir."/egged</b><br/>";
	
	}
	$dirchecks = (is_dir($sourcedir)?$eggdirCheckGood."<b>SOURCE DIR FOUND</b>":$eggdirCheckBad."<b>SOURCE DIR NOT FOUND</b> - ".$sourcedir)."<br/><br/><b>PLEASE CONFIRM YOUR WEBSITE URL:</b> ".$boardurl."<br/><br/><b>Failed a test? Please Post or PM me here</br>
			<a href='http://www.daniel15.com/forum/index.php/topic,354.0.html'>EggAvatar's Official Thread of Daniel15's Forum</a>
			<br/>to get help<br/></b><br/>";

	return "<p>{$eggdirCheck}{$testGD}{$dirchecks}Let your users change custom titles: <input type='checkbox' name='info1' checked='yes'>
			<br/>Let your users write their own custom titles: <input type='checkbox' name='info2' checked='yes'>
			<br/>Adjust users Karma depending on item: <input type='checkbox' name='info3'>
			<br/>Turn Debug mode on(Only enable if you have problems): <input type='checkbox' name='info4'>";
}
	
function getUseInput() {
	global $context, $scripturl, $settings, $txt, $eggSelect, $item_info, $boardurl;

	$previewTaunt = "";
	$eggCT = "";
	if($item_info[1])
	{
		$eggCT = "<br/>Send Taunt:<input type='text' name='eggtaunt' size='50' ";
		if(!$item_info[2])
			$eggCT .= "disabled='true'";
		$eggCT .=  "value=\"".$eggSelect[0]['taunt']."\">";
		
		$previewTaunt = ";eggtaunt.value = eggsend.options[eggsend.selectedIndex].label;";
		
	}
	$eggText = "";
	$i = 0;
	foreach($eggSelect as $key)
	{
		$eggText .= "<OPTION id='".$key['image']."' value='{$i}' label='".htmlspecialchars($eggSelect[$i]['taunt'], ENT_QUOTES)."'>".$key['name']."";
		$i++;
	}

	return "<script type='text/javascript'>
function previewPic(sel)
{
document.eggP.src = '".$boardurl."/Sources/shop/item_images/' + sel.options[sel.selectedIndex].id;


}

</script>
Egg User: <input type='text' name='egguser' size='50'>
			<a href='{$scripturl}?action=findmember;input=egguser;quote=0;sesc={$context['session_id']}' onclick='return reqWin(this.href, 350, 400);'><img src='{$settings['images_url']}/icons/assist.gif' border='0' alt='{$txt['find_members']}' /> Find Member</a>
			{$eggCT}
			<br/>Send what:
			<SELECT name='eggsend' onChange='previewPic(this){$previewTaunt}'>
			{$eggText}
			 </SELECT>
			 
			 <br/>Egg Preview: <img name='eggP'src='".$boardurl."/Sources/shop/item_images/".$eggSelect[0]['image']."' align='texttop'/>
			 
			 "
			 ;
}

function onUse() {
    global $sourcedir, $db_prefix, $context, $item_info, $boardurl, $scripturl, $eggSelect, $modSettings, $boarddir, $dontColourme, $memberContext, $enablePm;
	$isAvatar = false;
	$isExternal = false;
	$isUploaded = false;
	
	if(!isset($item_info[4]))
		$item_info[4] = false;
	
	if(($_POST['eggtaunt'] == "")||(!isset($_POST['eggtaunt'])))
		$eggTaunt = $eggSelect[$_POST['eggsend']]['taunt'];
	else
		$eggTaunt = $_POST['eggtaunt'];
	
	if($userID = mysql_fetch_assoc(db_query("SELECT `ID_MEMBER` , `memberName`, `avatar` FROM {$db_prefix}members WHERE memberName = '".$_POST['egguser']."' OR realName = '".$_POST['egguser']."' LIMIT 1", __FILE__, __LINE__)))
	{	
		
		if($userID['avatar'] != '')
		{
			if(file_exists($modSettings['avatar_directory'].'/'.$userID['avatar']))
				$source_file = $modSettings['avatar_directory'].'/'.htmlentities($userID['avatar'], ENT_QUOTES);
			elseif(file_exists($boarddir.'/'.$userID['avatar']))
				$source_file = $boarddir.'/'.htmlspecialchars($userID['avatar']);
			else
			{
				$isExternal = true;
				$source_file = htmlspecialchars($userID['avatar'], ENT_QUOTES);
				$source_file = preg_replace('('.$boardurl.')', $boarddir, $source_file);
			}	
			$imageDetails = getimagesize($source_file);
			if(empty($imageDetails)){
				$source_file = preg_replace("/[ ]/", "%20", $source_file);
				$source_file = preg_replace("/&/", "%26", $source_file);
				$source_file = preg_replace("/amp;/", "", $source_file);
			}
			
			$isAvatar = true;
		}
		elseif($attach = mysql_fetch_assoc(db_query("SELECT `ID_ATTACH` , `ID_MEMBER` , `attachmentType`, `filename` FROM {$db_prefix}attachments WHERE ID_MEMBER = '".$userID['ID_MEMBER']."' LIMIT 1", __FILE__, __LINE__)))
		{
			$isUploaded = true;
			$isAvatar = true;
			if($attach["attachmentType"] == 0)
				$source_file = $modSettings['attachmentUploadDir'].'/'.$attach["filename"];
			else
				$source_file = $modSettings['custom_avatar_dir'].'/'.$attach["filename"];
		}
		if($isAvatar)
		{
			//add the egg
			$egg_source = $sourcedir."/shop/item_images/".$eggSelect[$_POST['eggsend']]['image'];
			$imageDetails = getimagesize($source_file);
			
			if((!isset($imageDetails['mime']))||(empty($imageDetails['mime'])))
			{
				loadMemberData($userID['ID_MEMBER']);
				loadMemberContext($userID['ID_MEMBER']);	

				$source_file = $memberContext[$userID['ID_MEMBER']]['avatar']['href'];
				if(!$isUploaded){
					$source_file = preg_replace('('.$boardurl.')', $boarddir, $source_file);
				}
				
				$imageDetails = getimagesize($source_file);
				if(empty($imageDetails)){
					$source_file = htmlspecialchars($source_file, ENT_QUOTES);
					$source_file = preg_replace("/[ ]/", "%20", $source_file);
					$source_file = preg_replace("/&/", "%26", $source_file);
					$source_file = preg_replace("/amp;/", "", $source_file);
				}
				
				
				$imageDetails = getimagesize($source_file);
				$isUploaded = false;
			}
			
			$eggDetails = getimagesize($egg_source);
			
			$img_width_e = $eggDetails[0];
			$img_height_e = $eggDetails[1];

			if( $eggDetails['mime'] == 'image/png')  { $egg_thumb = imagecreatefrompng($egg_source); }
			elseif( $eggDetails['mime'] == 'image/gif')  { $egg_thumb = imagecreatefromgif($egg_source);}
			else {  
			if($item_info[4])
			{
			echo "Please Copy this infomation and include it in your post or PM</br>
			<a href='http://www.daniel15.com/forum/index.php/topic,354.0.html'>EggAvatars Official Thread of Daniel15's Forum</a>
			<br/>for help debugging this problem<br/>";
			echo "Egg_Source: ".$egg_source."<br/>";
			echo "Egg Details: <pre>", print_r($eggDetails), "</pre><br/>";
			echo "Avatar Source :".$source_file."<br/>";
			echo "Image Details: <pre>", print_r($imageDetails), "</pre><br/>";
			echo "Source Dir: ".$sourcedir."<br/>";
			echo "Source Url: ".$boardurl."<br/>";
			echo "Board Dir: ".$boarddir."<br/>";
			echo '<pre>',print_r(gd_info()),'</pre>';
			}
			die("Egg is an unknown filetype"); }
			
			$img_width = $imageDetails[0];
			$img_height = $imageDetails[1];
			
			if($imageDetails['mime'] == 'image/jpeg'){$img_source = imagecreatefromjpeg($source_file); }
			elseif( $imageDetails['mime'] == 'image/png')  { $img_source = imagecreatefrompng($source_file); }
			elseif( $imageDetails['mime'] == 'image/gif')  { $img_source = imagecreatefromgif($source_file);}
			else {  
			if($item_info[4])
			{
			echo "Please Copy this infomation and include it in your post or PM</br>
			<a href='http://www.daniel15.com/forum/index.php/topic,354.0.html'>EggAvatars Official Thread of Daniel15's Forum</a>
			<br/>for help debugging this problem<br/>";
			echo "Egg_Source: ".$egg_source."<br/>";
			echo "Egg Details: <pre>", print_r($eggDetails), "</pre><br/>";
			echo "Avatar Source :".$source_file."<br/>";
			echo "Image Details: <pre>", print_r($imageDetails), "</pre><br/>";
			echo "Source Dir: ".$sourcedir."<br/>";
			echo "Source Url: ".$boardurl."<br/>";
			echo "Board Dir: ".$boarddir."<br/>";
			echo '<pre>',print_r(gd_info()),'</pre>';
			}
			die("Avatar is an unknown filetype"); }
			
			if(($isUploaded)&&(!empty($modSettings['avatar_max_height_upload'])))
			{
				$maxHeight = $modSettings['avatar_max_height_upload'];
				$maxWidth = $modSettings['avatar_max_width_upload'];
			}
			elseif(($isExternal)&&(!empty($modSettings['avatar_max_height_external'])))
			{
				$maxHeight = $modSettings['avatar_max_height_external'];
				$maxWidth = $modSettings['avatar_max_width_external'];
			}
			else
			{
				$maxHeight = $img_height;
				$maxWidth = $img_width;
			}
			
			
			
			if(($maxWidth < $img_width)||($maxHeight < $img_height))
			{
				if($img_height < $img_width)
				{
					$img_width_new = $maxWidth;
					$img_height_new = $img_height/($img_width/$maxWidth);
				}
				else
				{
					$img_height_new = $maxHeight;
					$img_width_new = $img_width/($img_height/$maxHeight);
				}
				$thumbnail =imagecreatetruecolor($img_width_new, $img_height_new);
				imagecopyresampled($thumbnail, $img_source, 0, 0, 0, 0, $img_width_new, $img_height_new, $img_width, $img_height);
				$img_width = $img_width_new;
				$img_height = $img_height_new;
			}
			else
			{
				$thumbnail =imagecreatetruecolor($img_width,$img_height);
				imagecopyresampled($thumbnail, $img_source, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			}
			
			$aspect_ratio_w = ($img_width_e*($eggSelect[$_POST['eggsend']]['ratio']));
			$aspect_ratio_h = ($img_height_e*($eggSelect[$_POST['eggsend']]['ratio']));			
	
			//random
			srand(time());
			$randomegg_ratio_h = (rand(0, $img_height-$aspect_ratio_h));
			srand(time()+100);
			$randomegg_ratio_w = (rand(0 , $img_width-$aspect_ratio_w));
			
			if($randomegg_ratio_h < 0)
				$randomegg_ratio_h = 0;
			if($randomegg_ratio_w < 0)
				$randomegg_ratio_w = 0;
			
			//ColourMe Start
			if($_POST['eggsend'] > $dontColourme)
			{
			$r_r = (rand(0 , 255));
			$g_r = (rand(0 , 255));
			$b_r = (rand(0 , 255));
   for($y=0; $y < $img_height_e; $y++) {
       for($x=0; $x < $img_width_e; $x++) {

       		$colors=imagecolorsforindex($egg_thumb, imagecolorat($egg_thumb, $x,$y));
			if(($colors['alpha'] < 100))
			{
		   $r= 255-$r_r;
           $g= 255-$g_r;
           $b= 255-$b_r;
			
           $test=imagecolorallocate($egg_thumb, $r,$g,$b);
           imagesetpixel($egg_thumb,$x, $y, $test);
		   }
    	}
		}
	}
			//ColourMe End		
			
						
			imagecopyresampled($thumbnail, $egg_thumb, $randomegg_ratio_w, $randomegg_ratio_h, 0, 0,    $aspect_ratio_w,    $aspect_ratio_h, $img_width_e, $img_height_e);
			
			$eggQuery = "UPDATE {$db_prefix}members SET avatar='".$boardurl."/egged/egged_".$userID['ID_MEMBER'].".png'";
			
			imagepng( $thumbnail, $boarddir.'/egged/egged_'.$userID['ID_MEMBER'].'.png');

			imagedestroy($img_source);
			imagedestroy($thumbnail);
			imagedestroy($egg_thumb);
			
			if($item_info[1])
			{
				$eggQuery .= ", usertitle = '".htmlspecialchars($eggTaunt, ENT_QUOTES)."'";
			}
			if($item_info[3])
			{	
				if(isset($eggSelect[$_POST['eggsend']]['karma']))
				{
				if($eggSelect[$_POST['eggsend']]['karma'] >=0)
					$eggQuery .= ", karmaGood = karmaGood + ".$eggSelect[$_POST['eggsend']]['karma']."";
				else
					$eggQuery .= ", karmaBad = karmaBad - ".$eggSelect[$_POST['eggsend']]['karma']."";
				}
			}
			$eggQuery .=  " WHERE ID_MEMBER='".$userID['ID_MEMBER']."' LIMIT 1";
			db_query($eggQuery, __FILE__, __LINE__);
			
			if($enablePm)
				eggPM($userID['ID_MEMBER'], htmlspecialchars($eggTaunt, ENT_QUOTES));
			
			return "Successfully Egged {$_POST['egguser']}<br/>Your victions new Avatar:<br/><img src='".$boardurl."/egged/egged_".$userID['ID_MEMBER'].".png'/>";
		}
		else
		{
			die("Unsuccessful, {$_POST['egguser']} does not have an avatar, here have another egg");
		}
	}
	else
	{
		die("Unsuccessful, {$_POST['egguser']} not found, here have another egg");
	}  

}

}

function eggPM($sendId, $eggMsg)
{
	global $context, $sourcedir, $ID_MEMBER;
	
	include_once($sourcedir . '/Subs-Post.php');
	
	// Who the IM will come from		 
	$pmfrom = array(
		'id' => $ID_MEMBER,
		'name' => $context['user']['name'],
		'username' => $context['user']['username']
	);
	
	// Who the IM is going to
	$pmto = array(
		'to' => array($sendId),
		'bcc' => array()
	);
	
	// The subject of the message
	$subject = 'Ive happened to egged you';
	// The actual message contents
	$message = 'Ive egged your Avatar :)\r\n\r\n'.$eggMsg;
	// Now, send!
	sendpm($pmto, $subject, $message, 0, $pmfrom);

}
?>
